---
title: PerformanceEventTiming
slug: Web/API/PerformanceEventTiming
tags:
  - API
  - Event Timing API
  - Interface
  - Performance
  - PerformanceEventTiming
  - Reference
  - Web Performance
---
<p>The <code>PerformanceEventTiming</code> interface of the Event Timing API provides timing information for the event types listed below.</p>

<div class="index">
<ul>
 <li>{{event("auxclick")}}</li>
 <li>{{event("beforeinput")}}</li>
 <li>{{event("click")}}</li>
 <li>{{event("compositionend")}}</li>
 <li>{{event("compositionstart")}}</li>
 <li>{{event("compositionupdate")}}</li>
 <li>{{event("contextmenu")}}</li>
 <li>{{event("dblclick")}}</li>
 <li>{{event("dragend")}}</li>
 <li>{{event("dragenter")}}</li>
 <li>{{event("dragleave")}}</li>
 <li>{{event("dragover")}}</li>
 <li>{{event("dragstart")}}</li>
 <li>{{event("drop")}}</li>
 <li>{{event("input")}}</li>
 <li>{{event("keydown")}}</li>
 <li>{{event("keypress")}}</li>
 <li>{{event("keyup")}}</li>
 <li>{{event("mousedown")}}</li>
 <li>{{event("mouseenter")}}</li>
 <li>{{event("mouseleave")}}</li>
 <li>{{event("mouseout")}}</li>
 <li>{{event("mouseover")}}</li>
 <li>{{event("mouseup")}}</li>
 <li>{{event("pointerover")}}</li>
 <li>{{event("pointerenter")}}</li>
 <li>{{event("pointerdown")}}</li>
 <li>{{event("pointerup")}}</li>
 <li>{{event("pointercancel")}}</li>
 <li>{{event("pointerout")}}</li>
 <li>{{event("pointerleave")}}</li>
 <li>{{event("gotpointercapture")}}</li>
 <li>{{event("lostpointercapture")}}</li>
 <li>{{event("touchstart")}}</li>
 <li>{{event("touchend")}}</li>
 <li>{{event("touchcancel")}}</li>
</ul>
</div>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><strong><code>{{domxref("PerformanceEventTiming.processingStart")}}</code></strong></dt>
 <dd>Returns the time at which event dispatch started.</dd>
 <dt><strong><code>{{domxref("PerformanceEventTiming.processingEnd")}}</code></strong></dt>
 <dd>Returns the time at which the event dispatch ended.</dd>
 <dt><strong><code>{{domxref("PerformanceEventTiming.cancelable")}}</code></strong></dt>
 <dd>Returns the associated event's cancelable attribute.</dd>
 <dt><strong><code>{{domxref("PerformanceEventTiming.target")}}</code></strong></dt>
 <dd>Returns the associated event's last target, if it is not removed.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt><strong><code>{{domxref("PerformanceEventTiming.toJSON()")}}</code></strong></dt>
 <dd>Converts the PerformanceEventTiming object to JSON.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example shows how to use the API for all events:</p>

<pre class="brush: js notranslate">const observer = new PerformanceObserver(function(list) {
    const perfEntries = list.getEntries().forEach(entry =&gt; {
        // Full duration
        const inputDuration = entry.duration;
        // Input delay (before processing event)
        const inputDelay = entry.processingStart - entry.startTime;
        // Synchronous event processing time (between start and end dispatch).
        const inputSyncProcessingTime = entry.processingEnd - entry.processingStart;
    });
});
// Register observer for event.
observer.observe({entryTypes: ["event"]});
</pre>

<p>We can also directly query the <a href="https://web.dev/fid">first input delay</a>. The first input delay or FID, measures the time from when a user first interacts with a page (i.e. when they click a link or tap on a button) to the time when the browser is actually able to begin processing event handlers in response to that interaction.</p>

<pre class="brush: js notranslate">// Keep track of whether (and when) the page was first hidden, see:
// https://github.com/w3c/page-visibility/issues/29
// NOTE: ideally this check would be performed in the document &lt;head&gt;
// to avoid cases where the visibility state changes before this code runs.
let firstHiddenTime = document.visibilityState === 'hidden' ? 0 : Infinity;
document.addEventListener('visibilitychange', (event) =&gt; {
  firstHiddenTime = Math.min(firstHiddenTime, event.timeStamp);
}, {once: true});

// Sends the passed data to an analytics endpoint. This code
// uses `/analytics`; you can replace it with your own URL.
function sendToAnalytics(data) {
  const body = JSON.stringify(data);
  // Use `navigator.sendBeacon()` if available, falling back to `fetch()`.
  (navigator.sendBeacon &amp;&amp; navigator.sendBeacon('/analytics', body)) ||
      fetch('/analytics', {body, method: 'POST', keepalive: true});
}

// Use a try/catch instead of feature detecting `first-input`
// support, since some browsers throw when using the new `type` option.
// https://bugs.webkit.org/show_bug.cgi?id=209216
try {
  function onFirstInputEntry(entry) {
    // Only report FID if the page wasn't hidden prior to
    // the entry being dispatched. This typically happens when a
    // page is loaded in a background tab.
    if (entry.startTime &lt; firstHiddenTime) {
      const fid = entry.processingStart - entry.startTime;

      // Report the FID value to an analytics endpoint.
      sendToAnalytics({fid});
    }
  }

  // Create a PerformanceObserver that calls `onFirstInputEntry` for each entry.
  const po = new PerformanceObserver((entryList) =&gt; {
    entryList.getEntries().forEach(onFirstInputEntry);
  });

  // Observe entries of type `first-input`, including buffered entries,
  // i.e. entries that occurred before calling `observe()` below.
  po.observe({
    type: 'first-input',
    buffered: true,
  });
} catch (e) {
  // Do nothing if the browser doesn't support this API.
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Event Timing API','#sec-performance-event-timing','PerformanceEventTiming')}}</td>
   <td>{{Spec2('Event Timing API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PerformanceEventTiming")}}</p>
